searchNodes=[{"doc":"A GenServer process to watch file system changes. The process receives data from Port, parse event, and send it to the worker process.","ref":"SecretsWatcherFileSystem.html","title":"SecretsWatcherFileSystem","type":"module"},{"doc":"Starts a GenServer process and linked to the current process. Options :dirs ([string], required), the list of directory to monitor. :backend (atom, optional), default backends: :fs_mac . Available backends: :fs_mac , :fs_inotify , and :fs_windows . :name (atom, optional), the name of the worker process to subscribe to the file system listerner. Alternative to using pid of the worker process. Additional backend implementation options. See backend module documents for more details. Examples Start monitoring /tmp/fs directory using the default :fs_mac backend of the current process: iex&gt; { :ok , pid } = SecretsWatcherFileSystem . start_link ( dirs : [ &quot;/tmp/fs&quot; ] ) iex&gt; SecretsWatcherFileSystem . subscribe ( pid ) Get instant ( latench: 0 ) notifications on file changes: iex&gt; SecretsWatcherFileSystem . start_link ( dirs : [ &quot;/path/to/some/files&quot; ] , latency : 0 ) Minitor a directory by a process name: iex&gt; SecretsWatcherFileSystem . start_link ( backend : :fs_mac , dirs : [ &quot;/tmp/fs&quot; ] , name : :worker ) iex&gt; SecretsWatcherFileSystem . subscribe ( :worker )","ref":"SecretsWatcherFileSystem.html#start_link/1","title":"SecretsWatcherFileSystem.start_link/1","type":"function"},{"doc":"Register the current process as a subscriber of a file_system worker. The pid you subscribed from will now receive messages like: { :file_event , worker_pid , { file_path , events } } { :file_event , worker_pid , :stop }","ref":"SecretsWatcherFileSystem.html#subscribe/1","title":"SecretsWatcherFileSystem.subscribe/1","type":"function"},{"doc":"A behaviour module for implementing different file system backend.","ref":"SecretsWatcherFileSystem.Backend.html","title":"SecretsWatcherFileSystem.Backend","type":"behaviour"},{"doc":"Get and validate backend module. Returns {:ok, backend_module} upon success and {:error, reason} upon failure. When nil is given, will return default backend by OS. When a custom module is given, make sure start_link/1 , bootstrap/0 and supported_system/0 are defnied.","ref":"SecretsWatcherFileSystem.Backend.html#backend/1","title":"SecretsWatcherFileSystem.Backend.backend/1","type":"function"},{"doc":"","ref":"SecretsWatcherFileSystem.Backend.html#c:bootstrap/0","title":"SecretsWatcherFileSystem.Backend.bootstrap/0","type":"callback"},{"doc":"","ref":"SecretsWatcherFileSystem.Backend.html#c:known_events/0","title":"SecretsWatcherFileSystem.Backend.known_events/0","type":"callback"},{"doc":"","ref":"SecretsWatcherFileSystem.Backend.html#c:supported_systems/0","title":"SecretsWatcherFileSystem.Backend.supported_systems/0","type":"callback"},{"doc":"File system backend for GNU/Linux, FreeBSD, and OpenBSD. This file is a fork from https://github.com/synrc/fs. Backend Options :recursive (bool, default: true), monitor directories and their contents recursively. Executable File Path Useful when running :secrets_watcher_file_system with escript. The default listener executable file is found through finding inotifywait from $PATH . Two ways to customize the executable file path: Module config with config.exs : config :secrets_watcher_file_system , :fs_inotify , executable_file : &quot;YOUR_EXECUTABLE_FILE_PATH&quot; ` System environment variable: export FILESYSTEM_FSINOTIFY_EXECUTABLE_FILE = &quot;YOUR_EXECUTABLE_FILE_PATH&quot; `","ref":"SecretsWatcherFileSystem.Backends.FSInotify.html","title":"SecretsWatcherFileSystem.Backends.FSInotify","type":"module"},{"doc":"Callback implementation for SecretsWatcherFileSystem.Backend.bootstrap/0 .","ref":"SecretsWatcherFileSystem.Backends.FSInotify.html#bootstrap/0","title":"SecretsWatcherFileSystem.Backends.FSInotify.bootstrap/0","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"SecretsWatcherFileSystem.Backends.FSInotify.html#child_spec/1","title":"SecretsWatcherFileSystem.Backends.FSInotify.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"SecretsWatcherFileSystem.Backends.FSInotify.html#init/1","title":"SecretsWatcherFileSystem.Backends.FSInotify.init/1","type":"function"},{"doc":"Callback implementation for SecretsWatcherFileSystem.Backend.known_events/0 .","ref":"SecretsWatcherFileSystem.Backends.FSInotify.html#known_events/0","title":"SecretsWatcherFileSystem.Backends.FSInotify.known_events/0","type":"function"},{"doc":"","ref":"SecretsWatcherFileSystem.Backends.FSInotify.html#parse_line/1","title":"SecretsWatcherFileSystem.Backends.FSInotify.parse_line/1","type":"function"},{"doc":"","ref":"SecretsWatcherFileSystem.Backends.FSInotify.html#parse_options/1","title":"SecretsWatcherFileSystem.Backends.FSInotify.parse_options/1","type":"function"},{"doc":"","ref":"SecretsWatcherFileSystem.Backends.FSInotify.html#start_link/1","title":"SecretsWatcherFileSystem.Backends.FSInotify.start_link/1","type":"function"},{"doc":"Callback implementation for SecretsWatcherFileSystem.Backend.supported_systems/0 .","ref":"SecretsWatcherFileSystem.Backends.FSInotify.html#supported_systems/0","title":"SecretsWatcherFileSystem.Backends.FSInotify.supported_systems/0","type":"function"},{"doc":"File system backend for MacOS. The built-in executable file will be compile upon first use. This file is a fork from https://github.com/synrc/fs. Backend Options :latency (float, default: 0.5), latency period. :no_defer (bool, default: false), enable no-defer latency modifier. Works with latency parameter. See FSEvent API documents https://developer.apple.com/documentation/coreservices/kfseventstreamcreateflagnodefer. :watch_root (bool, default: false), watch for when the root path has changed. Set the flag true to monitor events when watching /tmp/fs/dir and run mv /tmp/fs /tmp/fx . See FSEvent API documents https://developer.apple.com/documentation/coreservices/kfseventstreamcreateflagwatchroot. recursive is enabled by default and it can'b be disabled for now. Executable File Path Useful when running :secrets_watcher_file_system with escript. The default listener executable file is priv/mac_listener within the folder of :secrets_watcher_file_system application. Two ways to customize the executable file path: Module config with config.exs : config :secrets_watcher_file_system , :fs_mac , executable_file : &quot;YOUR_EXECUTABLE_FILE_PATH&quot; ` System environment variable: export FILESYSTEM_FSMAC_EXECUTABLE_FILE = &quot;YOUR_EXECUTABLE_FILE_PATH&quot; `","ref":"SecretsWatcherFileSystem.Backends.FSMac.html","title":"SecretsWatcherFileSystem.Backends.FSMac","type":"module"},{"doc":"Callback implementation for SecretsWatcherFileSystem.Backend.bootstrap/0 .","ref":"SecretsWatcherFileSystem.Backends.FSMac.html#bootstrap/0","title":"SecretsWatcherFileSystem.Backends.FSMac.bootstrap/0","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"SecretsWatcherFileSystem.Backends.FSMac.html#child_spec/1","title":"SecretsWatcherFileSystem.Backends.FSMac.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"SecretsWatcherFileSystem.Backends.FSMac.html#init/1","title":"SecretsWatcherFileSystem.Backends.FSMac.init/1","type":"function"},{"doc":"Callback implementation for SecretsWatcherFileSystem.Backend.known_events/0 .","ref":"SecretsWatcherFileSystem.Backends.FSMac.html#known_events/0","title":"SecretsWatcherFileSystem.Backends.FSMac.known_events/0","type":"function"},{"doc":"","ref":"SecretsWatcherFileSystem.Backends.FSMac.html#parse_line/1","title":"SecretsWatcherFileSystem.Backends.FSMac.parse_line/1","type":"function"},{"doc":"","ref":"SecretsWatcherFileSystem.Backends.FSMac.html#parse_options/1","title":"SecretsWatcherFileSystem.Backends.FSMac.parse_options/1","type":"function"},{"doc":"","ref":"SecretsWatcherFileSystem.Backends.FSMac.html#start_link/1","title":"SecretsWatcherFileSystem.Backends.FSMac.start_link/1","type":"function"},{"doc":"Callback implementation for SecretsWatcherFileSystem.Backend.supported_systems/0 .","ref":"SecretsWatcherFileSystem.Backends.FSMac.html#supported_systems/0","title":"SecretsWatcherFileSystem.Backends.FSMac.supported_systems/0","type":"function"},{"doc":"File system backend for any OS. Backend Options :interval (integer, default: 1000), polling interval Using FSPoll Backend Unlike other backends, polling backend is never automatically chosen in any OS environment, despite being usable on all platforms. To use polling backend, one has to explicitly specify in the backend option.","ref":"SecretsWatcherFileSystem.Backends.FSPoll.html","title":"SecretsWatcherFileSystem.Backends.FSPoll","type":"module"},{"doc":"Callback implementation for SecretsWatcherFileSystem.Backend.bootstrap/0 .","ref":"SecretsWatcherFileSystem.Backends.FSPoll.html#bootstrap/0","title":"SecretsWatcherFileSystem.Backends.FSPoll.bootstrap/0","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"SecretsWatcherFileSystem.Backends.FSPoll.html#child_spec/1","title":"SecretsWatcherFileSystem.Backends.FSPoll.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"SecretsWatcherFileSystem.Backends.FSPoll.html#init/1","title":"SecretsWatcherFileSystem.Backends.FSPoll.init/1","type":"function"},{"doc":"Callback implementation for SecretsWatcherFileSystem.Backend.known_events/0 .","ref":"SecretsWatcherFileSystem.Backends.FSPoll.html#known_events/0","title":"SecretsWatcherFileSystem.Backends.FSPoll.known_events/0","type":"function"},{"doc":"","ref":"SecretsWatcherFileSystem.Backends.FSPoll.html#start_link/1","title":"SecretsWatcherFileSystem.Backends.FSPoll.start_link/1","type":"function"},{"doc":"Callback implementation for SecretsWatcherFileSystem.Backend.supported_systems/0 .","ref":"SecretsWatcherFileSystem.Backends.FSPoll.html#supported_systems/0","title":"SecretsWatcherFileSystem.Backends.FSPoll.supported_systems/0","type":"function"},{"doc":"File system backend for Windows. Need binary executable file packaged in to use this backend. This file is a fork from https://github.com/synrc/fs. Backend Options :recursive (bool, default: true), monitor directories and their contents recursively Executable File Path Useful when running :secrets_watcher_file_system with escript. The default listener executable file is priv/inotifywait.exe within the folder of :secrets_watcher_file_system application. Two ways to customize the executable file path: Module config with config.exs : config :secrets_watcher_file_system , :fs_windows , executable_file : &quot;YOUR_EXECUTABLE_FILE_PATH&quot; ` System environment variable: export FILESYSTEM_FSWINDOWS_EXECUTABLE_FILE = &quot;YOUR_EXECUTABLE_FILE_PATH&quot; `","ref":"SecretsWatcherFileSystem.Backends.FSWindows.html","title":"SecretsWatcherFileSystem.Backends.FSWindows","type":"module"},{"doc":"Callback implementation for SecretsWatcherFileSystem.Backend.bootstrap/0 .","ref":"SecretsWatcherFileSystem.Backends.FSWindows.html#bootstrap/0","title":"SecretsWatcherFileSystem.Backends.FSWindows.bootstrap/0","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"SecretsWatcherFileSystem.Backends.FSWindows.html#child_spec/1","title":"SecretsWatcherFileSystem.Backends.FSWindows.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"SecretsWatcherFileSystem.Backends.FSWindows.html#init/1","title":"SecretsWatcherFileSystem.Backends.FSWindows.init/1","type":"function"},{"doc":"Callback implementation for SecretsWatcherFileSystem.Backend.known_events/0 .","ref":"SecretsWatcherFileSystem.Backends.FSWindows.html#known_events/0","title":"SecretsWatcherFileSystem.Backends.FSWindows.known_events/0","type":"function"},{"doc":"","ref":"SecretsWatcherFileSystem.Backends.FSWindows.html#parse_line/1","title":"SecretsWatcherFileSystem.Backends.FSWindows.parse_line/1","type":"function"},{"doc":"","ref":"SecretsWatcherFileSystem.Backends.FSWindows.html#parse_options/1","title":"SecretsWatcherFileSystem.Backends.FSWindows.parse_options/1","type":"function"},{"doc":"","ref":"SecretsWatcherFileSystem.Backends.FSWindows.html#start_link/1","title":"SecretsWatcherFileSystem.Backends.FSWindows.start_link/1","type":"function"},{"doc":"Callback implementation for SecretsWatcherFileSystem.Backend.supported_systems/0 .","ref":"SecretsWatcherFileSystem.Backends.FSWindows.html#supported_systems/0","title":"SecretsWatcherFileSystem.Backends.FSWindows.supported_systems/0","type":"function"},{"doc":"SecretsWatcherFileSystem Worker Process with the backend GenServer, receive events from Port Process and forward it to subscribers.","ref":"SecretsWatcherFileSystem.Worker.html","title":"SecretsWatcherFileSystem.Worker","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"SecretsWatcherFileSystem.Worker.html#child_spec/1","title":"SecretsWatcherFileSystem.Worker.child_spec/1","type":"function"},{"doc":"An Elixir file change watcher wrapper based on FS , the native file system listener.","ref":"readme.html","title":"SecretsWatcherFileSystem","type":"extras"},{"doc":"MacOS - fsevent GNU/Linux, FreeBSD and OpenBSD - inotify Windows - inotify-win On MacOS 10.14, to compile mac_listener , run: open /Library/Developer/CommandLineTools/Packages/macOS_SDK_headers_for_macOS_10.14.pkg","ref":"readme.html#system-support","title":"SecretsWatcherFileSystem - System Support","type":"extras"},{"doc":"Put :secrets_watcher_file_system in the deps and application part of your mix.exs : defmodule Excellent.Mixfile do use Mix.Project def project do ... end defp deps do [ { :secrets_watcher_file_system , &quot;~&gt; 0.2&quot; , only : :test } , ] end ... end Subscription API You can spawn a worker and subscribe to events from it: { :ok , pid } = SecretsWatcherFileSystem . start_link ( dirs : [ &quot;/path/to/some/files&quot; ] ) SecretsWatcherFileSystem . subscribe ( pid ) or { :ok , pid } = SecretsWatcherFileSystem . start_link ( dirs : [ &quot;/path/to/some/files&quot; ] , name : :my_monitor_name ) SecretsWatcherFileSystem . subscribe ( :my_monitor_name ) The pid you subscribed from will now receive messages like: { :file_event , worker_pid , { file_path , events } } and { :file_event , worker_pid , :stop } Example Using GenServer defmodule Watcher do use GenServer def start_link ( args ) do GenServer . start_link ( __MODULE__ , args ) end def init ( args ) do { :ok , watcher_pid } = SecretsWatcherFileSystem . start_link ( args ) SecretsWatcherFileSystem . subscribe ( watcher_pid ) { :ok , %{ watcher_pid : watcher_pid } } end def handle_info ( { :file_event , watcher_pid , { path , events } } , %{ watcher_pid : watcher_pid } = state ) do # Your own logic for path and events { :noreply , state } end def handle_info ( { :file_event , watcher_pid , :stop } , %{ watcher_pid : watcher_pid } = state ) do # Your own logic when monitor stop { :noreply , state } end end","ref":"readme.html#usage","title":"SecretsWatcherFileSystem - Usage","type":"extras"},{"doc":"For each platform, you can pass extra options to the underlying listener process. Each backend supports different extra options, check backend module documentation for more details. Here is an example to get instant notifications on file changes for MacOS: SecretsWatcherFileSystem . start_link ( dirs : [ &quot;/path/to/some/files&quot; ] , latency : 0 , watch_root : true )","ref":"readme.html#backend-options","title":"SecretsWatcherFileSystem - Backend Options","type":"extras"},{"doc":"Copyright (C) 2016 Xiangrong Hao Everyone is permitted to copy and distribute verbatim or modified copies of this license document, and changing it is allowed as long as the name is changed. DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION You just DO WHAT THE FUCK YOU WANT TO.","ref":"readme.html#license","title":"SecretsWatcherFileSystem - License","type":"extras"}]